<?php
function bw_settings(){

	if(isset($_POST['write_better_preferred'])){ 
		$write_better_preferred = stripslashes_deep($_POST['write_better_preferred']);
		update_option( 'write_better_preferred', $write_better_preferred );
	} else {
		if(get_option('write_better_preferred')){
			$write_better_preferred = get_option('write_better_preferred');  //Required on page load and write_better_preferred is not set
		}
		
	}
	if(isset($_POST['add_preferred'])){
		$write_better_preferred[] =  array( 'preferred' => '', 'non_preferred' => '');
	}

	if(isset($_POST['drop_preferred'])){
		$drop = $_POST['drop_preferred'];
		array_splice($write_better_preferred, $drop, 1);
	}
	if(!isset($write_better_preferred) || count($write_better_preferred) == 0){
		$write_better_preferred[] =  array( 'preferred' => '', 'non_preferred' => '');
	}
	?>

	<div class="wrap">
		<h2 class="nav-tab-wrapper">
			<a href="?page=better-writing&tab=about" class="nav-tab <?php if(!isset($_GET['tab']) || ($_GET['tab'] == 'about')){ echo 'nav-tab-active'; }?>"><?php _e('About'); ?></a>
			<a href="?page=better-writing&tab=readability_settings" class="nav-tab <?php if(isset($_GET['tab']) && ($_GET['tab'] == 'readability_settings')){ echo 'nav-tab-active'; }?>"><?php _e('Readability'); ?></a>
			<a href="?page=better-writing&tab=preferred_terms" class="nav-tab <?php if(isset($_GET['tab']) && ($_GET['tab'] == 'preferred_terms')){ echo 'nav-tab-active'; }?>"><?php _e('Preferred terms'); ?></a>
		</h2>

		<?php
		if(!isset($_GET['tab']) || ($_GET['tab'] == 'about')){
		?>
			<h3><?php _e('Accuracy of readability tests');?></h3>
			<p><?php _e('Readability algorithms can only provide a rough guide. They tend to reward short sentences made up of short words. They do not take into account spelling, grammar or sentence structure. When applied with common sense they are a useful writing tool. A good readability score does not always guarantee good readability.');?></p>
			<h3><?php _e('Reading Ease scores'); ?></h3>
			<p><?php _e('The Flesch reading ease score is based on a range of 0-100. With lower values for hard to read text and higher values for easier text. ') ?></p>
			<p><?php _e('It is possible for very short or highly complex text to fall outside this range. In these situations the score might not be indicative of readability.') ?></p>
			<ul>
				<li><a href="http://en.wikipedia.org/wiki/Flesch-Kincaid#Flesch_Reading_Ease" target="_blank">Flesch-Kincaid Reading Ease</a></li>
			</ul>

			<h3><?php _e('Grade level scores'); ?></h3>
			<p><?php _e('Grade level readability scores are based on grades within the American education system. The scores are roughly equivalent to the number of years of education a person might require to comprehend the text. Scores over 22 should generally be considered graduate level text. ');?></p>
			<p><?php _e('Each scoring method uses a different formula and some methods are preferred for particular writing styles or types of content.');?></p>
			<ul>
				<li><a href="http://en.wikipedia.org/wiki/Gunning-Fog_Index" target="_blank">Gunning-Fog Score</a></li>
				<li><a href="http://en.wikipedia.org/wiki/Coleman-Liau_Index" target="_blank">Coleman-Liau Index</a></li>
				<li><a href="http://en.wikipedia.org/wiki/SMOG_Index" target="_blank">SMOG Index</a></li>
				<li><a href="http://en.wikipedia.org/wiki/Automated_Readability_Index" target="_blank">Automated Readability Index</a></li>	
			</ul>

			<h3><?php _e('Language support for readability tests'); ?></h3>
			<p><?php _e('Some readability algorithms use syllable counting to determine their scores. The algorithm used to determine syllables is designed to work with English text. As a result scores for other languages might be inaccurate.'); ?></p>
			<p><?php _e('The Coleman-Liau Index as well as the Automated Readability Index do not use syllable counting, as a result they might give more accurate scores for non English text.'); ?></p>
		<?php 
		}

		if(isset($_GET['tab']) && ($_GET['tab'] == 'readability_settings')){
		?>
			<form method="post" action="options.php">
				<h2><?php _e('Scoring options', 'bw_lang'); ?></h2>
				<?php
				settings_fields( 'bw-settings-group' );
				?>
				<table class="form-table">
					<tr>
						<th scope="row"><?php _e('Scoring method'); ?></th>
						<td>
							<ul>
								<li><input type="radio" class="bw_readability_method" id="readability_method_flesch" name="readability_method"  <?php checked(get_option('readability_method'), 'flesch', true); ?> value="flesch"/> <label class="wide" for="readability_method_flesch"><?php _e('Flesch reading ease formula') ?></label></li>
								<li><input type="radio" class="bw_readability_method" id="readability_method_coleman" name="readability_method"  <?php checked(get_option('readability_method'), 'coleman', true); ?> value="coleman"/> <label class="wide" for="readability_method_coleman"><?php _e('Coleman Liau index') ?></label></li>
								<li><input type="radio" class="bw_readability_method" id="readability_method_gunning" name="readability_method"  <?php checked(get_option('readability_method'), 'gunning', true); ?> value="gunning"/> <label class="wide" for="readability_method_gunning"><?php _e('Gunning fog index') ?></label></li>
								<li><input type="radio" class="bw_readability_method" id="readability_method_smog" name="readability_method"  <?php checked(get_option('readability_method'), 'smog', true); ?> value="smog" /> <label class="wide" for="readability_method_smog"><?php _e('SMOG Index') ?></label></li>
								<li><input type="radio" class="bw_readability_method" id="readability_method_ari" name="readability_method"  <?php checked(get_option('readability_method'), 'ari', true); ?> value="ari" /> <label class="wide" for="readability_method_ari"><?php _e('Automated readability index') ?></label></li>
							</ul>
						</td>
					</tr>
					<tr>
						<th scope="row"><?php _e('Target score', 'bw_lang') ?></th>
						<td>
							<p><input type="text" id="readability_target" name="readability_target" value="<?php echo get_option('readability_target'); ?>" /></p>
						</td>
					</tr>
				</table>

				<h2><?php _e('Display options', 'bw_lang'); ?></h2>
				<table class="form-table">
					<tr>
						<th>
							<?php _e('Show readability score column', 'bw_lang'); ?>
						</th>
						<td>
							<input type="checkbox" id="readability_column"  name="readability_column" value="readability_column" <?php checked(get_option('readability_column'), 'readability_column', true); ?> /> <label for="readability_column"><?php _e('Yes', 'bw_lang'); ?></label>
						</td>
					</tr>
					<tr>
						<th>
							<?php _e('Show readability info when editing', 'bw_lang'); ?>
						</th>
						<td>
							<ul>
								<li><input type="checkbox" id="readability_required_pages"  name="readability_required_pages" value="readability_required" <?php checked(get_option('readability_required_pages'), 'readability_required', true); ?> /> <label for="readability_required_pages"><?php _e('Pages', 'bw_lang'); ?></label></li>
								<li><input type="checkbox" id="readability_required_posts"  name="readability_required_posts" value="readability_required" <?php checked(get_option('readability_required_posts'), 'readability_required', true); ?> /> <label for="readability_required_posts"><?php _e('Posts', 'bw_lang'); ?></label></li>
							</ul>
							<?php
							$args=array(
							  'public'   => true,
							  '_builtin' => false
							); 
							if(get_post_types($args,'names')){
								$post_types=get_post_types($args,'names');
								echo '<ul>';
								foreach ($post_types as $post_type ) {
									$post_obj = get_post_type_object($post_type);
									?>
									<li> <input type="checkbox" id="readability_required_<?php echo $post_type; ?>"  name="readability_required_<?php echo $post_type; ?>" value="readability_required" <?php checked(get_option('readability_required_'.$post_type), 'readability_required', true); ?> /> <label for="readability_required_<?php echo $post_type; ?>"><?php echo $post_obj->labels->name; ?></label> </li>
									<?php
								}
								echo '</ul>';
							}
							?>
						</td>
					</tr>
				</table>
				<p class="submit">
					<input type="submit" class="button-primary" value="<?php _e('Save Changes', 'bw_lang'); ?>" />
				</p>
			</form>
		<?php 
		}

		if(isset($_GET['tab']) && ($_GET['tab'] == 'preferred_terms')){
		?>
			<form method="post" action="">
				<h2><?php _e('Preferred terms', 'bw_lang'); ?></h2>
				<p><?php _e('Enter a comma seperated list of non-preferred words or phrases on the left and preferred words or phrases on the right. Matches are not case sensitive.', 'bw_lang'); ?></p>
				<table  style="width: 600px;">
					<tr><th rowspan="4"><?php _e('Examples:'); ?></th><td><strong><?php _e('Non-preferred terms'); ?></strong></td><td><strong><?php _e('Preferred terms'); ?></strong></td></tr>
					<tr><td><?php _e('garbage collection'); ?></td><td><?php _e('waste management'); ?></td></tr>
					<tr><td><?php _e('essays, columns, papers'); ?></td><td><?php _e('articles, reports'); ?></td></tr>
					<tr><td><?php _e('training, research, instruction'); ?></td><td><?php _e('education'); ?></td></tr>
				</table>

				<table style="width: 100%; text-align: left;">
					<tr>
						<th><?php _e('Non-preferred terms', 'bw_lang'); ?></th>
						<th><?php _e('Preferred terms', 'bw_lang'); ?></th>
						<th></th>
					</tr>
					<?php
					foreach($write_better_preferred as $index => $value){ 
					?>
					<tr>
						<td><textarea style="width: 95%;" name="write_better_preferred[<?php echo $index; ?>][non_preferred]"><?php echo $value['non_preferred']; ?></textarea></td>
						<td><textarea style="width: 95%;" name="write_better_preferred[<?php echo $index; ?>][preferred]"><?php echo $value['preferred']; ?></textarea></td>
						<td>
						<button type="submit" name="drop_preferred" class="button-secondary" value="<?php echo $index; ?>"><?php _e('Remove', 'bw_lang'); ?></button>
						</td>
					</tr>
					<?php 
					}
					?>
				</table>

				<p><input type="submit" name="add_preferred" class="button-secondary" value="<?php _e('Add row', 'bw_lang') ?>"/></p>
				<p><input type="submit" class="button-primary" name="save_preferred" value="<?php _e('Save Changes', 'bw_lang') ?>"/></p>
			</form>
		<?php 
		}
		?>
	</div>
	<?php
}
